// SettingDialog.cpp : implementation file
//

#include "stdafx.h"
#include "MainFrm.h"
#include "SettingDialog.h"
#include <io.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//
#define CHECK_CWND_RETURN(pWnd) if(pWnd == NULL || IsWindow(pWnd->m_hWnd) == FALSE) { return; }
//
/////////////////////////////////////////////////////////////////////////////
// CSettingDialog dialog
IMPLEMENT_DYNAMIC(CSettingDialog, CDialogEx)

CSettingDialog::CSettingDialog(SettingInfo* pSettingInfo, CWnd* pParent /*=NULL*/)
	: CDialogEx(CSettingDialog::IDD, pParent)
{
	m_pSettingInfo = pSettingInfo;
	//LoadSetting(m_settingInfo);
	m_nRefreshTime = pSettingInfo->nRefreshTime;
}


CSettingDialog::~CSettingDialog()
{
	
}

void CSettingDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingDialog)
	DDX_Text(pDX, IDC_EDIT_REFRESH, m_nRefreshTime);
	DDX_Control(pDX, IDC_CUSTOM_GRID, m_Grid);
	DDX_Control(pDX, IDC_COMBO_SOUNDTIP, m_CmbSoundTip);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingDialog, CDialogEx)
	//{{AFX_MSG_MAP(CSettingDialog)
	ON_BN_CLICKED(IDC_BUTTON_ITEMUP, OnButtonItemup)
	ON_BN_CLICKED(IDC_BUTTON_ITEMDOWN, OnButtonItemdown)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_ADD, &CSettingDialog::OnBnClickedButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_DEL, &CSettingDialog::OnBnClickedButtonDel)
	ON_CBN_SELCHANGE(IDC_COMBO_SOUNDTIP, OnSelchangeComboSoundTip)
END_MESSAGE_MAP()

BOOL CSettingDialog::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	//ʼµȷѡ
	//
	if (InitGrid() != 0)
	{
		AfxMessageBox("ʼбʧܣ");
		return FALSE;
	}
	//
	// µؼ
	UpdateData(FALSE);

	if (m_pSettingInfo->nSoundTip < 2)
	{
		m_CmbSoundTip.SetCurSel(m_pSettingInfo->nSoundTip);
	}
	else
	{
		//
		CString strFile = m_pSettingInfo->SoundFile.c_str();
		//ļڣб
		if (!strFile.IsEmpty() && _access(strFile,0) == 0)
		{
			m_CmbSoundTip.AddString(strFile);
			m_CmbSoundTip.SetCurSel(3);
		}
		else
		{
			m_CmbSoundTip.DeleteString(3);
			m_CmbSoundTip.SetCurSel(1);
		}
	}

	return TRUE;
}

int CSettingDialog::InitGrid()
{
	m_Grid.EnableDragAndDrop(FALSE);
	m_Grid.SetGridLines();
	//m_Grid.SetTextBkColor(RGB(0,0,255));
	m_Grid.SetHeaderSort(FALSE);
	m_Grid.EnableSelection(TRUE);
	m_Grid.SetSingleRowSelection(TRUE);
	m_Grid.SetEditable(TRUE);
	m_Grid.SetRowResize(TRUE);
	m_Grid.SetColumnResize(TRUE);
	m_Grid.SetFixedColumnSelection(FALSE);
	m_Grid.SetTrackFocusCell(FALSE);
	m_Grid.SetFixedRowCount(1);//̶һ
	m_Grid.SetFixedColumnCount(1);//̶һ
	m_Grid.SetRowCount(1);
	m_Grid.SetColumnCount(giGridColumnCount);
	//m_Grid.SetRowHeight(0,gGridRowHeight);
	//m_Grid.AutoSizeColumns();
	GV_ITEM Item;
	Item.mask = GVIF_TEXT|GVIF_FORMAT;
	Item.row = 0;
	Item.nFormat = DT_LEFT|DT_WORDBREAK;
	//
	for (int i = 0;i < giGridColumnCount; ++i)
	{
		Item.col = i;
		Item.strText.Format(_T("%s"),gsGridColumns[i].szText);
		m_Grid.SetItem(&Item);
		m_Grid.SetColumnWidth(i,gsGridColumns[i].nWidth);
	}
	//ʾ
	if (InitGridData() != 0)
	{
		return -1;
	}
	//
	return 0;
}

int CSettingDialog::InitGridData()
{
	CString strText;
	int iRow = 0;
	for(auto it = m_pSettingInfo->vecIPInfo.begin(); it != m_pSettingInfo->vecIPInfo.end(); it++)
	{
		iRow = m_Grid.GetRowCount();
		strText.Format("%d",iRow);
		m_Grid.InsertRow(strText);
		m_Grid.SetItemText(iRow,1,it->ip.c_str());
		strText.Format("%d",it->port);
		m_Grid.SetItemText(iRow,2,strText);
		m_Grid.SetItemText(iRow,3,it->remark.c_str());
	}

	return 0;
}
/////////////////////////////////////////////////////////////////////////////
// CSettingDialog message handlers

void CSettingDialog::OnButtonItemup() 
{
	int iSelMin = m_Grid.GetSelectedCellRange().GetMinRow();
	int iSelMax = m_Grid.GetSelectedCellRange().GetMaxRow();
	int iSelCount = iSelMax - iSelMin + 1;
	int iRowCount = m_Grid.GetRowCount() - 1;//ȥ
	if (iSelCount < 1 || iSelCount >= iRowCount)
		return;

	if (iSelCount != 1)
	{
		AfxMessageBox("ѡƶ");
		return;
	}

	//һе
	if (iSelMin == 1)
	{
		AfxMessageBox("һвƣ");
		return;
	}

	CString str1 = m_Grid.GetItemText(iSelMin, 1);
	CString str2 = m_Grid.GetItemText(iSelMin, 2);
	CString str3 = m_Grid.GetItemText(iSelMin, 3);

	m_Grid.SetItemText(iSelMin, 1, m_Grid.GetItemText(iSelMin-1, 1));
	m_Grid.SetItemText(iSelMin, 2, m_Grid.GetItemText(iSelMin-1, 2));
	m_Grid.SetItemText(iSelMin, 3, m_Grid.GetItemText(iSelMin-1, 3));

	m_Grid.SetItemText(iSelMin-1, 1, str1);
	m_Grid.SetItemText(iSelMin-1, 2, str2);
	m_Grid.SetItemText(iSelMin-1, 3, str3);

	for(int i = 1; i < 4; i++)
	{
		if (m_Grid.IsCellSelected(iSelMin, i))
		{
			m_Grid.SetItemState(iSelMin, i, LVIS_OVERLAYMASK);
			m_Grid.SetItemState(iSelMin - 1, i, LVIS_SELECTED | LVIS_FOCUSED);
		}
	}
	
	m_Grid.Refresh();
}

void CSettingDialog::OnButtonItemdown() 
{
	int iSelMin = m_Grid.GetSelectedCellRange().GetMinRow();
	int iSelMax = m_Grid.GetSelectedCellRange().GetMaxRow();
	int iSelCount = iSelMax - iSelMin + 1;
	int iRowCount = m_Grid.GetRowCount() - 1;//ȥ
	if (iSelCount < 1 || iSelCount >= iRowCount)
		return;

	if (iSelCount != 1)
	{
		AfxMessageBox("ѡƶ");
		return;
	}

	//һе
	if (iSelMin == iRowCount)
	{
		AfxMessageBox("һвƣ");
		return;
	}

	CString str1 = m_Grid.GetItemText(iSelMin, 1);
	CString str2 = m_Grid.GetItemText(iSelMin, 2);
	CString str3 = m_Grid.GetItemText(iSelMin, 3);

	m_Grid.SetItemText(iSelMin, 1, m_Grid.GetItemText(iSelMin+1, 1));
	m_Grid.SetItemText(iSelMin, 2, m_Grid.GetItemText(iSelMin+1, 2));
	m_Grid.SetItemText(iSelMin, 3, m_Grid.GetItemText(iSelMin+1, 3));

	m_Grid.SetItemText(iSelMin+1, 1, str1);
	m_Grid.SetItemText(iSelMin+1, 2, str2);
	m_Grid.SetItemText(iSelMin+1, 3, str3);

	for(int i = 1; i < 4; i++)
	{
		if (m_Grid.IsCellSelected(iSelMin, i))
		{
			m_Grid.SetItemState(iSelMin, i, LVIS_OVERLAYMASK);
			m_Grid.SetItemState(iSelMin + 1, i, LVIS_SELECTED | LVIS_FOCUSED);
		}
	}

	m_Grid.Refresh();
}

void CSettingDialog::OnOK() 
{
	UpdateData(TRUE); // ؼֵֵԱ

	m_pSettingInfo->nRefreshTime = m_nRefreshTime;
	m_pSettingInfo->vecIPInfo.clear();

	int iRowCount = m_Grid.GetRowCount();
	for (int i = 1;i < iRowCount;++i)
	{
		if (m_Grid.GetItemText(i, 1).IsEmpty())
			continue;
		IPInfo info( m_Grid.GetItemText(i, 1).GetBuffer(), atoi( m_Grid.GetItemText(i, 2) ), m_Grid.GetItemText(i, 3).GetBuffer() );
		m_pSettingInfo->vecIPInfo.push_back(info);
	}

	m_pSettingInfo->nSoundTip = m_CmbSoundTip.GetCurSel();
	//
	if (SaveSetting(*m_pSettingInfo) < 0)
	{
		AfxMessageBox("ʧܣ");
		return;
	}

	CDialog::OnOK();
}


void CSettingDialog::OnBnClickedButtonAdd()
{
	// TODO: ڴӿؼ֪ͨ
	m_Grid.InsertRow("");
	int nLine = m_Grid.GetRowCount()-1;
	CString strLine;
	strLine.Format("%d", nLine);
	m_Grid.SetItemText(nLine, 0, strLine);
	m_Grid.RedrawRow(nLine);
}


void CSettingDialog::OnBnClickedButtonDel()
{
	// TODO: ڴӿؼ֪ͨ
	if(m_Grid.GetSelectedCount()>0)
	{
		int iRow = m_Grid.GetSelectedCellRange().GetMinRow();
		if(iRow<1 || iRow >= m_Grid.GetRowCount())
			return;
		m_Grid.DeleteRow(iRow);
	}
	m_Grid.Invalidate();
}


void CSettingDialog::OnSelchangeComboSoundTip()
{
	//
	int iSel = m_CmbSoundTip.GetCurSel();
	char szBuf[257] = { 0 };
	sprintf_s(szBuf,"%d",iSel);

	m_pSettingInfo->nSoundTip = iSel;

	if (iSel == 2)
	{
		CString strFileName;
		char szCurPath[MAX_PATH + 1] = { 0 };
		GetCurrentDirectory(MAX_PATH,szCurPath);//浱ǰĿ¼
		//
		SetCurrentDirectory("..\\sounds\\");
		//
		CFileDialog dlg(TRUE,_T(".wav"),strFileName,OFN_OVERWRITEPROMPT,
			_T("wavļ(*.wav)|*.wav||"),NULL);
		if (dlg.DoModal() != IDOK)
		{
			return;
		}
		strFileName = dlg.GetPathName();
		SetCurrentDirectory(szCurPath);//ظǰĿ¼
		//
		sprintf_s(szBuf,"%s",strFileName);
		//
		m_CmbSoundTip.DeleteString(3);
		iSel = m_CmbSoundTip.AddString(strFileName);
		m_CmbSoundTip.SetCurSel(iSel);
	} 
	else if (iSel == 3)
	{
		m_CmbSoundTip.GetLBText(3,szBuf);
	}
	else
	{
		m_CmbSoundTip.DeleteString(3);
		sprintf_s(szBuf,"%s","");
	}

	m_pSettingInfo->SoundFile = szBuf;
}