
// stdafx.cpp : ֻ׼ļԴļ
// TradeMonitor.pch ΪԤͷ
// stdafx.obj ԤϢ

#include "stdafx.h"
#include "Lib\tinyxml2.h"

int LoadSetting(SettingInfo& settingInfo)
{
	tinyxml2::XMLDocument doc;
    try
    {
        if(doc.LoadFile(SETTING_FILENAME) == 0)
        {
            tinyxml2::XMLElement* pRootEle = doc.RootElement();        
            for(auto pEle = pRootEle->FirstChildElement(); pEle != nullptr; pEle = pEle->NextSiblingElement())
            {
				if (strcmp(pEle->Name(), "RefreshTime") == 0)
				{
					settingInfo.nRefreshTime = pEle->IntAttribute("val");
				}

				if (strcmp(pEle->Name(), "IPInfo") == 0)
				{
					IPInfo info( pEle->Attribute("ip"), pEle->IntAttribute("port"), pEle->Attribute("remark") );
					settingInfo.vecIPInfo.push_back(info);
				}

				if (strcmp(pEle->Name(), "Sound") == 0)
				{
					settingInfo.nSoundTip = pEle->IntAttribute("val");
					settingInfo.SoundFile = pEle->IntAttribute("file");
				}
            }

			return 0;
        }
		else
		{
			return -1;
		}
    }
    catch(...)
	{ 
		return -1;
	}
}

int SaveSetting(const SettingInfo& settingInfo)
{
	try
    {
		tinyxml2::XMLDocument doc;
		doc.LinkEndChild(doc.NewDeclaration("xml version=\"1.0\" encoding=\"GBK\""));
		tinyxml2::XMLElement* pRootEle = doc.NewElement("root");
		doc.LinkEndChild(pRootEle);

		tinyxml2::XMLElement* pNewEle;

		pNewEle = doc.NewElement("RefreshTime");
		pNewEle->SetAttribute("val", settingInfo.nRefreshTime);
		pRootEle->LinkEndChild(pNewEle);

		pNewEle = doc.NewElement("Sound");
		pNewEle->SetAttribute("val", settingInfo.nSoundTip);
		pNewEle->SetAttribute("file", settingInfo.SoundFile.c_str());
		pRootEle->LinkEndChild(pNewEle);

		for(auto it = settingInfo.vecIPInfo.begin(); it != settingInfo.vecIPInfo.end(); ++it)
		{
			pNewEle = doc.NewElement("IPInfo");
			pNewEle->SetAttribute("ip", it->ip.c_str());
			pNewEle->SetAttribute("port", it->port);
			pNewEle->SetAttribute("remark", it->remark.c_str());

			pRootEle->LinkEndChild(pNewEle);
		}
		doc.SaveFile(SETTING_FILENAME);

		return 0;
	}
    catch(...)
	{ 
		return -1;
	}
}